'////////////////////////////////////////////////////////////////////////////////////////////
'//                               KoXo Developpement                                       //
'//                                 (C) 2006-20016                                         //
'//                              Logon & Logoff logger                                     //
'//                            Call params : Path Action [ShowLogonServer] [ShowComputerIP]//
'//                                Examples : \\SRV\LOGS$ "[LOGON] "                       //
'//                                           \\SRV\LOGS$ "[LOGOFF]" 1 0                   //
'//                                           \\SRV\LOGS$ "[LOGON] " 1 1                   //
'////////////////////////////////////////////////////////////////////////////////////////////
Dim Path, Action, Arr, ShowComputerIP, ShowLogonServer
ShowComputerIP=False
ShowLogonServer=False
GetArgs Path,Action,ShowLogonServer,ShowComputerIP
LogFile Path & "\USERS",GetUserName,LogLine(Action,GetUserName,GetComputerName, _ 
                                            GetLogonServer,GetDomainName,ShowLogonServer, _ 
                                            ShowComputerIP)
If IsThinClient Then 
   LogFile Path & "\THIN-CLIENTS",GetThinClientName,LogLine(Action,GetUserName, _ 
                                                            GetComputerName,GetLogonServer, _
                                                            GetDomainName,ShowLogonServer, _ 
                                                            ShowComputerIP)
   Else 
   LogFile Path & "\COMPUTERS",GetComputerName,LogLine(Action,GetUserName,GetComputerName, _
                                                       GetLogonServer,GetDomainName, _ 
                                                       ShowLogonServer,ShowComputerIP)
   End If
WScript.Quit
'////////////////////////////////////////////////////////////////////////////////////////////
'// Args
Function GetArgs(Path,Action,ShowLogonServer,ShowComputerIP)
 On Error Resume Next
 Dim objArg
 Set objArgs=WScript.Arguments
 If objArgs.Count>0 Then
    For i=0 To objArgs.Count-1 
        If i=0 Then Path=objArgs.Item(i) End If
        If i=1 Then Action=objArgs.Item(i) End If
        If i=2 Then ShowLogonServer=(objArgs.Item(i)=1) End If
        If i=3 Then ShowComputerIP=(objArgs.Item(i)=1) End If
    Next
 Else 
  Path=""
  Action="?"
 End If
End Function
'////////////////////////////////////////////////////////////////////////////////////////////
'// Log File
Function LogFile(Path,Obj,Line)
 On Error Resume Next
 Dim objFSO, TextFile, MyFile
 Set objFSO=CreateObject("Scripting.FileSystemObject")
 If Not objFSO.FolderExists(Path) Then objFSO.CreateFolder(Path) End If
 MyFile=Path & "\" & Obj & ".LOG"
 If Not objFSO.FileExists(MyFile) Then 
    Set TextFile=objFSO.OpenTextFile(MyFile,2,True)
    TextFile.WriteLine(Pattern(80))
    TextFile.WriteLine("# (C) 2006-2016 KoXo Dev")
    TextFile.WriteLine("# Sessions log for : """ & Obj & """")
    TextFile.WriteLine("# Creation date : " & GetFormattedDate("/") &_ 
                       " " & GetFormattedTime(":"))
    TextFile.WriteLine(Pattern(80))
    TextFile.WriteLine("#")
    Else
    Set TextFile=objFSO.OpenTextFile(MyFile,8,True)
    End If 
 TextFile.WriteLine(Line)
 TextFile.Close
End Function
'////////////////////////////////////////////////////////////////////////////////////////////
'// Log Line
Function LogLine(Action,UserName,ComputerName,LogonServer,DomainName,ShowLogonServer,ShowComputerIP)
 On Error Resume Next
 LogLine=Action & " " &  GetFormattedDate("/") & " " & GetFormattedTime(":") & " "
 If ShowLogonServer Then LogLine=LogLine & "LogonServer=""" & LogonServer & """ " End If
 LogLine=LogLine & "Computer=""" & ComputerName & """"
 If ShowComputerIP Then LogLine=LogLine & " {IP=" & IPAddress & "}" End If
 LogLine=LogLine & " User=""" & DomainName & "\" & UserName & """"
End Function
'////////////////////////////////////////////////////////////////////////////////////////////
'// Is Thin client 
Function IsThinClient()
 Const HKEY_CURRENT_USER=&H80000001
 strComputer="."
 Set oReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & _ 
     strComputer & "\root\default:StdRegProv")
 strKeyPath = "Volatile Environment"
 strValueName="CLIENTNAME"
 oReg.GetStringValue HKEY_CURRENT_USER, strKeyPath ,strValueName, strValue 
 If IsNull(strValue) Then 
    oReg.EnumKey HKEY_CURRENT_USER, strKeyPath, arrSubKeys
    If IsArray(arrSubKeys) And Not(IsEmpty(arrSubKeys)) Then 
       For Each SubKey In arrSubKeys
           oReg.GetStringValue HKEY_CURRENT_USER, strKeyPath & "\" & SubKey,strValueName, strValue
       Next
    End If
 End If   
 If strValue="" Then 
    IsThinClient=False
    Else
    IsThinClient=True
    End If
End Function
'////////////////////////////////////////////////////////////////////////////////////////////
'// Get Thin Client Name
Function GetThinClientName()
 Const HKEY_CURRENT_USER=&H80000001
 strComputer="."
 Set oReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & _ 
     strComputer & "\root\default:StdRegProv")
 strKeyPath = "Volatile Environment"
 strValueName="CLIENTNAME"
 oReg.GetStringValue HKEY_CURRENT_USER, strKeyPath ,strValueName, strValue 
 If IsNull(strValue) Then 
    oReg.EnumKey HKEY_CURRENT_USER, strKeyPath, arrSubKeys
    If IsArray(arrSubKeys) And Not(IsEmpty(arrSubKeys)) Then 
       For Each SubKey In arrSubKeys
           oReg.GetStringValue HKEY_CURRENT_USER, strKeyPath & "\" & SubKey,strValueName, strValue
       Next
    End If
 End If   
 GetThinClientName=strValue
End Function
'////////////////////////////////////////////////////////////////////////////////////////////
'// Get Computer Name
Function GetComputerName()
 On Error Resume Next
 Dim objNetwork
 Set objNetwork=WScript.CreateObject("WScript.Network")
 GetComputerName=objNetwork.ComputerName 
End Function
'////////////////////////////////////////////////////////////////////////////////////////////
'// Get User Name
Function GetUserName()
 On Error Resume Next
 Dim objNetwork
 Set objNetwork=WScript.CreateObject("WScript.Network")
 GetUserName=objNetwork.UserName
End Function
'////////////////////////////////////////////////////////////////////////////////////////////
'// Get Domain Name
Function GetDomainName()
 On Error Resume Next
 Dim objNetwork
 Set objNetwork=WScript.CreateObject("WScript.Network")
 GetDomainName=objNetwork.UserDomain
End Function
'//////////////////////
'// Get the LogonServer
function GetLogonServer()
Dim objShell
Set objShell=Wscript.CreateObject("Wscript.Shell")
GetLogonServer=Replace(objShell.ExpandEnvironmentStrings("%LOGONSERVER%"),"\\","")
End Function
'////////////////////////////////////////////////////////////////////////////////////////////
'// Get IP Address
Function IPAddress()
 On Error Resume Next
 Dim Res
 Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
 Res=""
 Set IPConfigSet=objWMIService.ExecQuery _
     ("Select * from Win32_NetworkAdapterConfiguration Where IPEnabled=TRUE")
 For Each IPConfig in IPConfigSet
    If Not IsNull(IPConfig.IPAddress) Then 
        For i=LBound(IPConfig.IPAddress) to UBound(IPConfig.IPAddress)
            Res=Res & IPConfig.IPAddress(i) & " "
        Next
    End If
 Next
 IPAddress=Trim(Res)
End Function
'////////////////////////////////////////////////////////////////////////////////////////////
'// Format Number in 2 digits
Function Format2(N)
 If N<10 Then N="0" & N End If
 Format2=N
End Function
'////////////////////////////////////////////////////////////////////////////////////////////
'// Date
Function GetFormattedDate(DateSeparator)
 strDate=CDate(Date)
 strDay=Format2(DatePart("d",strDate))
 strMonth=Format2(DatePart("m", strDate))
 strYear=DatePart("yyyy",strDate)
 GetFormattedDate = strDay & DateSeparator & strMonth & DateSeparator & strYear
End Function
'////////////////////////////////////////////////////////////////////////////////////////////
'// Time 
Function GetFormattedTime(TimeSeparator)
 strTime=CDate(Time)
 strHour=Format2(DatePart("h",strTime))
 strMin=Format2(DatePart("n", strTime))
 strSec=Format2(DatePart("s",strTime))
 GetFormattedTime = strHour & TimeSeparator & strMin & TimeSeparator & strSec
End Function
'////////////////////////////////////////////////////////////////////////////////////////////
'// Pattern
Function Pattern(L)
 Dim Res,I
 Res=""
 For I=1 To L
     Res=Res & "#"
 Next
 Pattern=Res
End Function
'////////////////////////////////////////////////////////////////////////////////////////////
