'////////////////////////////////////////////////////////////////////////////////////////////////////////////
'(c) 2006-2019 KoXo Developpement
'For x86 & x64
'Script for calling KoXoLabel / Multisite  version
'Display in the right-up corner of the screen : Company, User Fullname, User Groups, Computer
'ID Picture support (Pictures in \\server\netlogon\Pictures) (KoXoLabel 1.2 required)
On Error Resume Next
Dim objNetwork, objShell
'Args
Set objArgs=WScript.Arguments
Param=""
SitePicFolder=""
If objArgs.Count>0 Then 
   For i=0 To objArgs.Count-1 
       If Instr(objArgs.Item(i),"SitePicturesFolder=")=0 Then 
          Param=Param&""""&objArgs.Item(i)&""" " 
          Else SitePicturesFolder=RemoveQuotes(GetValue(objArgs.Item(i)))
       End If
   Next    
   End If
'User Name
Set objNetwork=WScript.CreateObject("WScript.Network")
strUserName=objNetwork.UserName
'Computer Name
Set objShell=WScript.CreateObject("WScript.Shell")
Computer=objShell.ExpandEnvironmentStrings("%CLIENTNAME%")
TSE=(Computer<>"" And Computer<>"%CLIENTNAME%" And Computer<>"Console")
If Not TSE Then Computer=objNetwork.ComputerName End If
'Get Domain
Set objDomain = GetObject("LDAP://rootDse")
objDC=objDomain.Get("DefaultNamingContext")
'LDAP Search
Set objConnection = CreateObject("ADODB.Connection")
objConnection.Open "Provider=ADsDSOObject;"
Set objCommand = CreateObject("ADODB.Command")
objCommand.ActiveConnection=objConnection
objCommand.CommandText = _
    "<LDAP://" & objDC & ">;(&(objectCategory=User)" & _
         "(samAccountName=" & strUserName & "));distinguishedName;subtree"
Set objRecordSet = objCommand.Execute
'If User exists
If objRecordset.RecordCount=1 Then
   objRecordSet.MoveFirst
   FQDN=objRecordSet.Fields("distinguishedName").Value
   LDAP="LDAP://" & FQDN
   Set objUser=GetObject _
       (LDAP) 
   Company=objUser.Get("company")  
   FullName=objUser.Get("sn")
   FullName=objUser.Get("givenName")  & " " & FullName
   PersonnalTitle=objUser.Get("personalTitle")
   If PersonnalTitle="" Then 
      Title=objUser.Get("title")
      Else
      Title=PersonnalTitle
      End If
   FullName=Title & " " & FullName
   FullName=Trim(FullName)
   If FullName="" Then FullName=objUser.Get("displayName") End If
   If FullName="" Then FullName=strUserName End If     
   arrFQDN=Split(FQDN,",")
   GS=GetValue(arrFQDN(1))
   GP=GetValue(arrFQDN(2))
   If SitePicturesFolder<>"" Then 
       SitePicturesFolder=SitePicturesFolder & "\"
      End If
   Picture="/IDPicture="&Replace(WScript.ScriptFullName,WScript.ScriptName,SitePicturesFolder&"Pictures\"&strUserName&".jpg")
   Param=Param&""""&FullName&";18"" ""("&GP&" / "&GS&")"" ""["&Computer&"]"""
   If Company<>"" Then
      Param=""""&Company&";24"" "&Param
      End If
   If OsIs64bits Then 
      KoXoLabelEXE="KoXoLabel64.exe" 
      Else 
      KoXoLabelEXE="KoXoLabel32.exe" 
      End If  
   KoXoLabel=Replace(WScript.ScriptFullName,WScript.ScriptName,KoXoLabelEXE)
   objShell.Run KoXoLabel & " " & Param & " """ & Picture & """", 1, True   
   End If   
objConnection.Close
WScript.Quit
'////////////////////////////////////////////////////////////////////////////////////////////////////////////
'Get Value from ValueName=Value
Function GetValue(Val)
 i=InStr(Val,"=")
 j=Len(Val)
 GetValue=Mid(Val,i+1,Len(Val)-i)
End Function
'////////////////////////////////////////////////////////////////////////////////////////////////////////////
'Remove framing quotes
Function RemoveQuotes(Val)
l=Len(Val)
If l>2 Then 
   If (Mid(Val,1,1)=Chr(34)) And (Mid(Val,L,1)=Chr(34)) Then 
       RemoveQuotes=Mid(Val,2,L-2)
   Else    
    RemoveQuotes=Val
   End If
Else
 RemoveQuotes=Val   
End If
End Function
'////////////////////////////////////////////////////////////////////////////////////////////////////////////
'64 bits ?
Function OsIs64bits
On Error Resume Next
Dim objWMIService,colOperatingSystems
strComputer="."
Set objWMIService=GetObject("winmgmts:" & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
Set colOperatingSystems=objWMIService.ExecQuery("Select * from Win32_OperatingSystem")
For Each objOperatingSystem in colOperatingSystems
    OSArchi=objOperatingSystem.OSArchitecture
Next
OsIs64bits=InStr(osarchi,"64")
End Function
'////////////////////////////////////////////////////////////////////////////////////////////////////////////